using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Windows.Forms.Design;
using System.Data;
using System.IO;



namespace P2PBackupClient
{
	
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	
	public class Client : System.Windows.Forms.Form
	{	
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.TabControl tabP2PBackup;
		private System.Windows.Forms.TabPage tabLogin;
		private System.Windows.Forms.TabPage tabShare;
		private System.Windows.Forms.TabPage tabCreateKey;
		private System.Windows.Forms.TabPage tabBackup;
		private System.Windows.Forms.TabPage tabRecovery;
		private System.Windows.Forms.Label lblIp;
		private System.Windows.Forms.TextBox txtIp;
		private System.Windows.Forms.TextBox txtPassword;
		private System.Windows.Forms.TextBox txtUsername;
		private System.Windows.Forms.Button btnLogin;
		private System.Windows.Forms.Label lblPassword;
		private System.Windows.Forms.Label lblUsername;
		private System.Windows.Forms.TextBox txtSharePath;
		private System.Windows.Forms.Button btnChFolder;
		private System.Windows.Forms.TextBox txtShareSize;
		private System.Windows.Forms.Label lblShareSize;
		private System.Windows.Forms.Button btnSaveShare;
		private System.Windows.Forms.FolderBrowserDialog fbdChoose;
		private System.Windows.Forms.Button btnCreateKeyPair;
		private System.Windows.Forms.Button btnBackup;
		private System.Windows.Forms.Label lblCurrentShare;
		private System.Windows.Forms.Button btnChFoldBack;
		private System.Windows.Forms.TextBox txtBackupPath;
		private System.Windows.Forms.Label lblBackup;
		private System.Windows.Forms.Button lblChFoldTemp;
		private System.Windows.Forms.TextBox txtTempPath;
		private System.Windows.Forms.Label lblTemp;
		private System.Windows.Forms.Label lblNameBackup;
		private System.Windows.Forms.TextBox txtNameBackup;
		private System.Windows.Forms.Label txtACS;
		private System.Windows.Forms.Button btnRecover;
		private System.Windows.Forms.ColumnHeader colBackup;
		private System.Windows.Forms.ColumnHeader colDate;
		private System.Windows.Forms.Label lblRecover;
		private System.Windows.Forms.CheckBox chkSaveLocal;
		private System.Windows.Forms.ListView lstRecovery;
		private System.Windows.Forms.ProgressBar prbKeyPair;
		private System.Windows.Forms.Button btnSendPubKey;
		private User user;
		private System.Windows.Forms.ProgressBar prbBackup;
		private System.Windows.Forms.ProgressBar prbRecovery;
		private System.Windows.Forms.Label lblRecovery;
		private bool online = false;
		

		public Client()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			user = new User();
			user.UpdateGUIEvent += new P2PBackupClient.User.UpdateGUIHandler(this.UpdateGUI);
			int i = 1;
			while(i < 5)
			{
				tabP2PBackup.Controls[i].Enabled = false;
				i++;
			}
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{	
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Client));
			this.tabP2PBackup = new System.Windows.Forms.TabControl();
			this.tabLogin = new System.Windows.Forms.TabPage();
			this.lblIp = new System.Windows.Forms.Label();
			this.txtIp = new System.Windows.Forms.TextBox();
			this.txtPassword = new System.Windows.Forms.TextBox();
			this.txtUsername = new System.Windows.Forms.TextBox();
			this.btnLogin = new System.Windows.Forms.Button();
			this.lblPassword = new System.Windows.Forms.Label();
			this.lblUsername = new System.Windows.Forms.Label();
			this.tabBackup = new System.Windows.Forms.TabPage();
			this.prbBackup = new System.Windows.Forms.ProgressBar();
			this.chkSaveLocal = new System.Windows.Forms.CheckBox();
			this.txtNameBackup = new System.Windows.Forms.TextBox();
			this.lblNameBackup = new System.Windows.Forms.Label();
			this.lblTemp = new System.Windows.Forms.Label();
			this.lblChFoldTemp = new System.Windows.Forms.Button();
			this.txtTempPath = new System.Windows.Forms.TextBox();
			this.lblBackup = new System.Windows.Forms.Label();
			this.btnChFoldBack = new System.Windows.Forms.Button();
			this.txtBackupPath = new System.Windows.Forms.TextBox();
			this.btnBackup = new System.Windows.Forms.Button();
			this.tabRecovery = new System.Windows.Forms.TabPage();
			this.lblRecovery = new System.Windows.Forms.Label();
			this.prbRecovery = new System.Windows.Forms.ProgressBar();
			this.lblRecover = new System.Windows.Forms.Label();
			this.lstRecovery = new System.Windows.Forms.ListView();
			this.colBackup = new System.Windows.Forms.ColumnHeader();
			this.colDate = new System.Windows.Forms.ColumnHeader();
			this.btnRecover = new System.Windows.Forms.Button();
			this.tabShare = new System.Windows.Forms.TabPage();
			this.btnSaveShare = new System.Windows.Forms.Button();
			this.lblShareSize = new System.Windows.Forms.Label();
			this.txtShareSize = new System.Windows.Forms.TextBox();
			this.btnChFolder = new System.Windows.Forms.Button();
			this.txtSharePath = new System.Windows.Forms.TextBox();
			this.lblCurrentShare = new System.Windows.Forms.Label();
			this.tabCreateKey = new System.Windows.Forms.TabPage();
			this.btnSendPubKey = new System.Windows.Forms.Button();
			this.prbKeyPair = new System.Windows.Forms.ProgressBar();
			this.btnCreateKeyPair = new System.Windows.Forms.Button();
			this.fbdChoose = new System.Windows.Forms.FolderBrowserDialog();
			this.txtACS = new System.Windows.Forms.Label();
			this.tabP2PBackup.SuspendLayout();
			this.tabLogin.SuspendLayout();
			this.tabBackup.SuspendLayout();
			this.tabRecovery.SuspendLayout();
			this.tabShare.SuspendLayout();
			this.tabCreateKey.SuspendLayout();
			this.SuspendLayout();
			// 
			// tabP2PBackup
			// 
			this.tabP2PBackup.Controls.Add(this.tabLogin);
			this.tabP2PBackup.Controls.Add(this.tabBackup);
			this.tabP2PBackup.Controls.Add(this.tabRecovery);
			this.tabP2PBackup.Controls.Add(this.tabShare);
			this.tabP2PBackup.Controls.Add(this.tabCreateKey);
			this.tabP2PBackup.Location = new System.Drawing.Point(24, 32);
			this.tabP2PBackup.Name = "tabP2PBackup";
			this.tabP2PBackup.SelectedIndex = 0;
			this.tabP2PBackup.Size = new System.Drawing.Size(480, 304);
			this.tabP2PBackup.TabIndex = 0;
			// 
			// tabLogin
			// 
			this.tabLogin.Controls.Add(this.lblIp);
			this.tabLogin.Controls.Add(this.txtIp);
			this.tabLogin.Controls.Add(this.txtPassword);
			this.tabLogin.Controls.Add(this.txtUsername);
			this.tabLogin.Controls.Add(this.btnLogin);
			this.tabLogin.Controls.Add(this.lblPassword);
			this.tabLogin.Controls.Add(this.lblUsername);
			this.tabLogin.Location = new System.Drawing.Point(4, 22);
			this.tabLogin.Name = "tabLogin";
			this.tabLogin.Size = new System.Drawing.Size(472, 278);
			this.tabLogin.TabIndex = 0;
			this.tabLogin.Text = "Login";
			// 
			// lblIp
			// 
			this.lblIp.Location = new System.Drawing.Point(56, 48);
			this.lblIp.Name = "lblIp";
			this.lblIp.Size = new System.Drawing.Size(72, 16);
			this.lblIp.TabIndex = 15;
			this.lblIp.Text = "IP:";
			this.lblIp.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// txtIp
			// 
			this.txtIp.Location = new System.Drawing.Point(128, 48);
			this.txtIp.Name = "txtIp";
			this.txtIp.Size = new System.Drawing.Size(136, 20);
			this.txtIp.TabIndex = 14;
			this.txtIp.Text = "";
			// 
			// txtPassword
			// 
			this.txtPassword.Location = new System.Drawing.Point(128, 128);
			this.txtPassword.Name = "txtPassword";
			this.txtPassword.PasswordChar = '*';
			this.txtPassword.Size = new System.Drawing.Size(136, 20);
			this.txtPassword.TabIndex = 9;
			this.txtPassword.Text = "";
			// 
			// txtUsername
			// 
			this.txtUsername.Location = new System.Drawing.Point(128, 88);
			this.txtUsername.Name = "txtUsername";
			this.txtUsername.Size = new System.Drawing.Size(136, 20);
			this.txtUsername.TabIndex = 8;
			this.txtUsername.Text = "";
			// 
			// btnLogin
			// 
			this.btnLogin.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.btnLogin.Location = new System.Drawing.Point(128, 160);
			this.btnLogin.Name = "btnLogin";
			this.btnLogin.Size = new System.Drawing.Size(136, 24);
			this.btnLogin.TabIndex = 12;
			this.btnLogin.Text = "Login";
			this.btnLogin.Click += new System.EventHandler(this.btnLogin_Click);
			// 
			// lblPassword
			// 
			this.lblPassword.Location = new System.Drawing.Point(56, 128);
			this.lblPassword.Name = "lblPassword";
			this.lblPassword.Size = new System.Drawing.Size(72, 16);
			this.lblPassword.TabIndex = 11;
			this.lblPassword.Text = "Password:";
			this.lblPassword.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblUsername
			// 
			this.lblUsername.Location = new System.Drawing.Point(56, 88);
			this.lblUsername.Name = "lblUsername";
			this.lblUsername.Size = new System.Drawing.Size(72, 16);
			this.lblUsername.TabIndex = 10;
			this.lblUsername.Text = "Username:";
			this.lblUsername.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// tabBackup
			// 
			this.tabBackup.Controls.Add(this.prbBackup);
			this.tabBackup.Controls.Add(this.chkSaveLocal);
			this.tabBackup.Controls.Add(this.txtNameBackup);
			this.tabBackup.Controls.Add(this.lblNameBackup);
			this.tabBackup.Controls.Add(this.lblTemp);
			this.tabBackup.Controls.Add(this.lblChFoldTemp);
			this.tabBackup.Controls.Add(this.txtTempPath);
			this.tabBackup.Controls.Add(this.lblBackup);
			this.tabBackup.Controls.Add(this.btnChFoldBack);
			this.tabBackup.Controls.Add(this.txtBackupPath);
			this.tabBackup.Controls.Add(this.btnBackup);
			this.tabBackup.Location = new System.Drawing.Point(4, 22);
			this.tabBackup.Name = "tabBackup";
			this.tabBackup.Size = new System.Drawing.Size(472, 278);
			this.tabBackup.TabIndex = 3;
			this.tabBackup.Text = "Backup";
			// 
			// prbBackup
			// 
			this.prbBackup.Location = new System.Drawing.Point(40, 208);
			this.prbBackup.Name = "prbBackup";
			this.prbBackup.Size = new System.Drawing.Size(376, 23);
			this.prbBackup.TabIndex = 13;
			// 
			// chkSaveLocal
			// 
			this.chkSaveLocal.Checked = true;
			this.chkSaveLocal.CheckState = System.Windows.Forms.CheckState.Checked;
			this.chkSaveLocal.Location = new System.Drawing.Point(152, 144);
			this.chkSaveLocal.Name = "chkSaveLocal";
			this.chkSaveLocal.Size = new System.Drawing.Size(112, 16);
			this.chkSaveLocal.TabIndex = 12;
			this.chkSaveLocal.Text = "Save local copy";
			// 
			// txtNameBackup
			// 
			this.txtNameBackup.Location = new System.Drawing.Point(152, 72);
			this.txtNameBackup.Name = "txtNameBackup";
			this.txtNameBackup.Size = new System.Drawing.Size(264, 20);
			this.txtNameBackup.TabIndex = 11;
			this.txtNameBackup.Text = "";
			// 
			// lblNameBackup
			// 
			this.lblNameBackup.Location = new System.Drawing.Point(40, 72);
			this.lblNameBackup.Name = "lblNameBackup";
			this.lblNameBackup.Size = new System.Drawing.Size(100, 16);
			this.lblNameBackup.TabIndex = 10;
			this.lblNameBackup.Text = "Name for backup:";
			this.lblNameBackup.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblTemp
			// 
			this.lblTemp.Location = new System.Drawing.Point(152, 104);
			this.lblTemp.Name = "lblTemp";
			this.lblTemp.Size = new System.Drawing.Size(117, 16);
			this.lblTemp.TabIndex = 9;
			this.lblTemp.Text = "Folder for local copy";
			// 
			// lblChFoldTemp
			// 
			this.lblChFoldTemp.Location = new System.Drawing.Point(40, 120);
			this.lblChFoldTemp.Name = "lblChFoldTemp";
			this.lblChFoldTemp.Size = new System.Drawing.Size(104, 24);
			this.lblChFoldTemp.TabIndex = 8;
			this.lblChFoldTemp.Text = "Choose Folder";
			this.lblChFoldTemp.Click += new System.EventHandler(this.lblChFoldTemp_Click);
			// 
			// txtTempPath
			// 
			this.txtTempPath.Location = new System.Drawing.Point(152, 120);
			this.txtTempPath.Name = "txtTempPath";
			this.txtTempPath.ReadOnly = true;
			this.txtTempPath.Size = new System.Drawing.Size(264, 20);
			this.txtTempPath.TabIndex = 7;
			this.txtTempPath.Text = "";
			// 
			// lblBackup
			// 
			this.lblBackup.Location = new System.Drawing.Point(152, 24);
			this.lblBackup.Name = "lblBackup";
			this.lblBackup.Size = new System.Drawing.Size(93, 16);
			this.lblBackup.TabIndex = 6;
			this.lblBackup.Text = "Folder to backup";
			// 
			// btnChFoldBack
			// 
			this.btnChFoldBack.Location = new System.Drawing.Point(40, 38);
			this.btnChFoldBack.Name = "btnChFoldBack";
			this.btnChFoldBack.Size = new System.Drawing.Size(104, 24);
			this.btnChFoldBack.TabIndex = 3;
			this.btnChFoldBack.Text = "Choose Folder";
			this.btnChFoldBack.Click += new System.EventHandler(this.btnChFoldBack_Click);
			// 
			// txtBackupPath
			// 
			this.txtBackupPath.Location = new System.Drawing.Point(152, 41);
			this.txtBackupPath.Name = "txtBackupPath";
			this.txtBackupPath.ReadOnly = true;
			this.txtBackupPath.Size = new System.Drawing.Size(264, 20);
			this.txtBackupPath.TabIndex = 2;
			this.txtBackupPath.Text = "";
			// 
			// btnBackup
			// 
			this.btnBackup.Location = new System.Drawing.Point(312, 168);
			this.btnBackup.Name = "btnBackup";
			this.btnBackup.Size = new System.Drawing.Size(104, 24);
			this.btnBackup.TabIndex = 0;
			this.btnBackup.Text = "Start Backup";
			this.btnBackup.Click += new System.EventHandler(this.btnBackup_Click);
			// 
			// tabRecovery
			// 
			this.tabRecovery.Controls.Add(this.lblRecovery);
			this.tabRecovery.Controls.Add(this.prbRecovery);
			this.tabRecovery.Controls.Add(this.lblRecover);
			this.tabRecovery.Controls.Add(this.lstRecovery);
			this.tabRecovery.Controls.Add(this.btnRecover);
			this.tabRecovery.Location = new System.Drawing.Point(4, 22);
			this.tabRecovery.Name = "tabRecovery";
			this.tabRecovery.Size = new System.Drawing.Size(472, 278);
			this.tabRecovery.TabIndex = 4;
			this.tabRecovery.Text = "Recovery";
			// 
			// lblRecovery
			// 
			this.lblRecovery.Location = new System.Drawing.Point(35, 192);
			this.lblRecovery.Name = "lblRecovery";
			this.lblRecovery.Size = new System.Drawing.Size(403, 16);
			this.lblRecovery.TabIndex = 9;
			// 
			// prbRecovery
			// 
			this.prbRecovery.Location = new System.Drawing.Point(35, 208);
			this.prbRecovery.Name = "prbRecovery";
			this.prbRecovery.Size = new System.Drawing.Size(403, 23);
			this.prbRecovery.TabIndex = 8;
			// 
			// lblRecover
			// 
			this.lblRecover.Location = new System.Drawing.Point(35, 24);
			this.lblRecover.Name = "lblRecover";
			this.lblRecover.Size = new System.Drawing.Size(397, 16);
			this.lblRecover.TabIndex = 7;
			this.lblRecover.Text = "Choose backup to recover. Recovery will be placed in original directory.";
			// 
			// lstRecovery
			// 
			this.lstRecovery.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																						  this.colBackup,
																						  this.colDate});
			this.lstRecovery.FullRowSelect = true;
			this.lstRecovery.Location = new System.Drawing.Point(35, 41);
			this.lstRecovery.Name = "lstRecovery";
			this.lstRecovery.Size = new System.Drawing.Size(403, 143);
			this.lstRecovery.TabIndex = 2;
			this.lstRecovery.View = System.Windows.Forms.View.Details;
			// 
			// colBackup
			// 
			this.colBackup.Text = "Backup name";
			this.colBackup.Width = 175;
			// 
			// colDate
			// 
			this.colDate.Text = "Date/Time";
			this.colDate.Width = 224;
			// 
			// btnRecover
			// 
			this.btnRecover.Location = new System.Drawing.Point(334, 240);
			this.btnRecover.Name = "btnRecover";
			this.btnRecover.Size = new System.Drawing.Size(104, 24);
			this.btnRecover.TabIndex = 1;
			this.btnRecover.Text = "Start Recovery";
			this.btnRecover.Click += new System.EventHandler(this.btnRecover_Click);
			// 
			// tabShare
			// 
			this.tabShare.Controls.Add(this.btnSaveShare);
			this.tabShare.Controls.Add(this.lblShareSize);
			this.tabShare.Controls.Add(this.txtShareSize);
			this.tabShare.Controls.Add(this.btnChFolder);
			this.tabShare.Controls.Add(this.txtSharePath);
			this.tabShare.Controls.Add(this.lblCurrentShare);
			this.tabShare.Location = new System.Drawing.Point(4, 22);
			this.tabShare.Name = "tabShare";
			this.tabShare.Size = new System.Drawing.Size(472, 278);
			this.tabShare.TabIndex = 1;
			this.tabShare.Text = "Share";
			// 
			// btnSaveShare
			// 
			this.btnSaveShare.Location = new System.Drawing.Point(312, 95);
			this.btnSaveShare.Name = "btnSaveShare";
			this.btnSaveShare.Size = new System.Drawing.Size(104, 24);
			this.btnSaveShare.TabIndex = 4;
			this.btnSaveShare.Text = "Send share";
			this.btnSaveShare.Click += new System.EventHandler(this.btnSaveShare_Click);
			// 
			// lblShareSize
			// 
			this.lblShareSize.Location = new System.Drawing.Point(72, 96);
			this.lblShareSize.Name = "lblShareSize";
			this.lblShareSize.Size = new System.Drawing.Size(72, 16);
			this.lblShareSize.TabIndex = 3;
			this.lblShareSize.Text = "Size(Mb):";
			this.lblShareSize.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// txtShareSize
			// 
			this.txtShareSize.Location = new System.Drawing.Point(152, 96);
			this.txtShareSize.Name = "txtShareSize";
			this.txtShareSize.Size = new System.Drawing.Size(149, 20);
			this.txtShareSize.TabIndex = 2;
			this.txtShareSize.Text = "";
			// 
			// btnChFolder
			// 
			this.btnChFolder.Location = new System.Drawing.Point(40, 38);
			this.btnChFolder.Name = "btnChFolder";
			this.btnChFolder.Size = new System.Drawing.Size(104, 24);
			this.btnChFolder.TabIndex = 1;
			this.btnChFolder.Text = "Choose Folder";
			this.btnChFolder.Click += new System.EventHandler(this.btnChFolder_Click);
			// 
			// txtSharePath
			// 
			this.txtSharePath.Location = new System.Drawing.Point(152, 41);
			this.txtSharePath.Name = "txtSharePath";
			this.txtSharePath.ReadOnly = true;
			this.txtSharePath.Size = new System.Drawing.Size(264, 20);
			this.txtSharePath.TabIndex = 0;
			this.txtSharePath.Text = "";
			// 
			// lblCurrentShare
			// 
			this.lblCurrentShare.Location = new System.Drawing.Point(152, 24);
			this.lblCurrentShare.Name = "lblCurrentShare";
			this.lblCurrentShare.Size = new System.Drawing.Size(271, 16);
			this.lblCurrentShare.TabIndex = 5;
			this.lblCurrentShare.Text = "Current share size: 0Mb";
			// 
			// tabCreateKey
			// 
			this.tabCreateKey.Controls.Add(this.btnSendPubKey);
			this.tabCreateKey.Controls.Add(this.prbKeyPair);
			this.tabCreateKey.Controls.Add(this.btnCreateKeyPair);
			this.tabCreateKey.Location = new System.Drawing.Point(4, 22);
			this.tabCreateKey.Name = "tabCreateKey";
			this.tabCreateKey.Size = new System.Drawing.Size(472, 278);
			this.tabCreateKey.TabIndex = 2;
			this.tabCreateKey.Text = "Create Key Pair";
			// 
			// btnSendPubKey
			// 
			this.btnSendPubKey.Location = new System.Drawing.Point(312, 120);
			this.btnSendPubKey.Name = "btnSendPubKey";
			this.btnSendPubKey.Size = new System.Drawing.Size(104, 24);
			this.btnSendPubKey.TabIndex = 2;
			this.btnSendPubKey.Text = "Send Public Key";
			this.btnSendPubKey.Click += new System.EventHandler(this.btnSendPubKey_Click);
			// 
			// prbKeyPair
			// 
			this.prbKeyPair.Location = new System.Drawing.Point(26, 40);
			this.prbKeyPair.Name = "prbKeyPair";
			this.prbKeyPair.Size = new System.Drawing.Size(419, 16);
			this.prbKeyPair.Step = 13;
			this.prbKeyPair.TabIndex = 1;
			// 
			// btnCreateKeyPair
			// 
			this.btnCreateKeyPair.Location = new System.Drawing.Point(312, 80);
			this.btnCreateKeyPair.Name = "btnCreateKeyPair";
			this.btnCreateKeyPair.Size = new System.Drawing.Size(104, 24);
			this.btnCreateKeyPair.TabIndex = 0;
			this.btnCreateKeyPair.Text = "Create KeyPair";
			this.btnCreateKeyPair.Click += new System.EventHandler(this.btnCreateKeyPair_Click);
			// 
			// txtACS
			// 
			this.txtACS.Location = new System.Drawing.Point(320, 8);
			this.txtACS.Name = "txtACS";
			this.txtACS.Size = new System.Drawing.Size(192, 16);
			this.txtACS.TabIndex = 7;
			this.txtACS.Text = "Accessible Space: ";
			// 
			// Client
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(528, 357);
			this.Controls.Add(this.txtACS);
			this.Controls.Add(this.tabP2PBackup);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "Client";
			this.Text = "P2PBackup Offline";
			this.tabP2PBackup.ResumeLayout(false);
			this.tabLogin.ResumeLayout(false);
			this.tabBackup.ResumeLayout(false);
			this.tabRecovery.ResumeLayout(false);
			this.tabShare.ResumeLayout(false);
			this.tabCreateKey.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// Saves username and password in user.
		/// Tells user to start connection, listen and login.
		/// </summary>
		private void Login()
		{
			try
			{  
				user.Username = txtUsername.Text;
				user.HashPassword(txtPassword.Text);
				if(!user.Connected)//not connected
					user.ConnectToHub(txtIp.Text,52561);
				if (user.Connected && !user.Run)//connected, but not listening
				{ 
					user.StartListening(); 	 
				}
				if (user.Connected && user.Run)//connected and listening
				{ 
					user.Login();
				}
			}
			catch(Exception ex)
			{
				MessageBox.Show(ex.Message,"Client.Login"); 
			}
		}

		/// <summary>
		/// Handles the changes in GUI
		/// </summary>
		/// <param name="command">command</param>
		/// <param name="param">parameter</param>
		private void UpdateGUI(string command, string param)
		{
			switch(command)
			{
				case "201"://login okey
					Online();
					break;
				case "208"://share okey
					if(online == false)
						Online();
					btnChFolder.Enabled = false;
					break;
				case "209"://key received
					Online();
					break;
				case "301"://share needed
					MessageBox.Show("You need to send a share. To make and send share use the Share tab.");
					tabP2PBackup.Controls[3].Enabled = true;
					break;
				case "302"://public key needed
					MessageBox.Show("You need to send public key. To create and send public key use the KeyPair tab.");
					tabP2PBackup.Controls[4].Enabled = true;
					if(user.KeyPairCrypto != null)
					{
						btnCreateKeyPair.Enabled = false;
					}
					else
					{
						btnSendPubKey.Enabled = false;
					}
					break;
				case "401"://User doesn't exist
					MessageBox.Show("Login failed. Please make sure that you have entered correct Username and Password.", "Warning");
					break;
				case "402"://Verification client-hub did not succeed
					MessageBox.Show("Login failed. Please make sure that you have entered correct Username and Password.", "Warning");
					break;
				case "403"://Not enough space for backup
					MessageBox.Show("Your accessible space is not enough for this backup. You can either change your current share size or make a smaller backup.", "Warning");
					btnBackup.Enabled = true;
					tabP2PBackup.Controls[2].Enabled = true;
					break;
				case "404"://Share is smaller than used space
					MessageBox.Show("Share is to small. You need to make a bigger share, use the share tab.");
					tabP2PBackup.Controls[1].Enabled = false;
					tabP2PBackup.Controls[2].Enabled = false;
					tabP2PBackup.Controls[4].Enabled = false;
					break;
				case "ACS":
					decimal lSize = Decimal.Parse(param);
					lSize = Decimal.Round(lSize / 1048576, 2);
					lSize.ToString();
					txtACS.Text = "Accessible Space: " + lSize + " MB";
					break;
				case "OUT":
					this.Text = "P2PBackup Offline";
					btnLogin.Text = "Login";
					int i = 1;
					while(i < 5)
					{
						tabP2PBackup.Controls[i].Enabled = false;
						i++;
					}
					break;
				case "DoneBackup":
					btnBackup.Enabled = true;
					FillListView();
					tabP2PBackup.Controls[2].Enabled = true;
					break;
				case "prbKeyPair":
					prbKeyPair.Value = Int32.Parse(param);
					prbKeyPair.PerformStep();
					break;
				case "initprbBackup":
					prbBackup.Value = 0;
					prbBackup.Maximum = Int32.Parse(param);
					break;
				case "prbBackup":
					prbBackup.Step = Int32.Parse(param);
					prbBackup.PerformStep();
					break;
				case "initprbRecovery":
					prbRecovery.Value = 0;
					prbRecovery.Maximum = Int32.Parse(param);
					lblRecovery.Text ="Downloading files:";
					break;
				case "prbRecovery":
					prbRecovery.Step = Int32.Parse(param);
					prbRecovery.PerformStep();
					if(prbRecovery.Value == prbRecovery.Maximum)
					{
						btnRecover.Enabled = true;
						tabP2PBackup.Controls[1].Enabled = true;
					}
					break;
			}
		}

		/// <summary>
		/// Makes changes in GUI when user has succeded login
		/// </summary>
		private void Online()
		{
			online = true;
			this.Text = "P2PBackup Online";
			btnLogin.Text = "Logout";
			FillListView();
			int i = 1;
			while(i < 5)
			{
				tabP2PBackup.Controls[i].Enabled = true;
				i++;
			}
			if(user.SharePath != null)
			{
				btnChFolder.Enabled = false;
				txtSharePath.Text = user.SharePath;
				lblCurrentShare.Text = "Current share size: " + user.ShareSize.ToString() + "Mb";
			}
			if(user.KeyPairCrypto != null)
				btnCreateKeyPair.Enabled = false;
			else
				btnSendPubKey.Enabled = false;
			FillListView();
		}

		/// <summary>
		/// Fills the listview on recovery-tab, all backups made are displayed for user
		/// </summary>
		private void FillListView()
		{
			lstRecovery.Items.Clear();
			int i = 0;
			string path;    // The location of indexfiles.
			path = Application.ExecutablePath;
			path = path.Substring(0, path.LastIndexOf(@"\") + 1);
			DirectoryInfo dInf = new DirectoryInfo(path);
			FileInfo[] fi = dInf.GetFiles(user.Username + "*.p2p");
			while(i < fi.Length)
			{
				string filename = fi[i].Name;
				filename = filename.Remove(0,user.Username.Length+1);
				filename = filename.Remove(filename.Length-4,4);
				string[] nameDate = new string[3];
				string[] item = new string[2];
				nameDate = filename.Split('_'); 
				item[0] = nameDate[2];
				item[1] = nameDate[0] + " " + nameDate[1].Insert(2,":");
				lstRecovery.Items.Add(new ListViewItem(item));
				i++;
			}
		}


		[STAThread]
		static void Main() 
		{
			Application.Run(new Client());
		}

		private void btnLogin_Click(object sender, System.EventArgs e)
		{
			if(user.Run == false)
				Login();
			else
				user.Disconnect(false);
		}

		private void btnSaveShare_Click(object sender, System.EventArgs e)
		{
			user.fileHand.SaveShareSize(txtShareSize.Text,txtSharePath.Text);
			user.SendShare(txtShareSize.Text,txtSharePath.Text);
			btnChFolder.Enabled = false;
		}

		private void btnChFolder_Click(object sender, System.EventArgs e)
		{ 
				fbdChoose.ShowDialog();
				txtSharePath.Text = fbdChoose.SelectedPath;
		}

		private void btnCreateKeyPair_Click(object sender, System.EventArgs e)
		{
			btnCreateKeyPair.Enabled = false;
			user.CreateKeyPair();
			btnSendPubKey.Enabled = true;	
		}

		private void btnBackup_Click(object sender, System.EventArgs e)
		{
			tabP2PBackup.Controls[2].Enabled = false;
			if(Directory.Exists(txtBackupPath.Text)&& txtNameBackup.Text != "")
			{
				btnBackup.Enabled = false;
				user.PrepareBackup(txtNameBackup.Text, txtBackupPath.Text, txtTempPath.Text,chkSaveLocal.Checked);
			}
			else
				MessageBox.Show("You need to choose both backup path and a name for backup.");
		}

		private void btnChFoldBack_Click(object sender, System.EventArgs e)
		{
			fbdChoose.ShowDialog();
			txtBackupPath.Text = fbdChoose.SelectedPath;
		}

		private void lblChFoldTemp_Click(object sender, System.EventArgs e)
		{
			fbdChoose.ShowDialog();
			txtTempPath.Text = fbdChoose.SelectedPath;
		}

		private void btnRecover_Click(object sender, System.EventArgs e)
		{
			tabP2PBackup.Controls[1].Enabled = false;
			btnRecover.Enabled = false;
			
			string date = lstRecovery.SelectedItems[0].SubItems[1].Text.Remove(10,6);
			string time = lstRecovery.SelectedItems[0].SubItems[1].Text.Remove(0,11);
			time = time.Remove(2,1);
			user.PrepareRecovery(user.Username+ "_" + date + "_" + time + "_" +lstRecovery.SelectedItems[0].Text);
		}

		private void btnSendPubKey_Click(object sender, System.EventArgs e)
		{
			user.SendPublicKey();
		}	
	}
}
