using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Net.Sockets;
using System.Net;
using System.Threading;

namespace P2PBackupHub
{
	/// <summary>
	/// Handles all connections from users, the interface
	/// </summary>
	public class Hub : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button cmdRun;
		private System.Windows.Forms.Label lblIP;
		private System.Windows.Forms.TextBox txtIP;
		private System.Windows.Forms.MainMenu mnuMenu;
		private System.Windows.Forms.MenuItem mnuFile;
		private System.Windows.Forms.MenuItem mnuAdd;
		private System.Windows.Forms.ListView lvwLogg;
		private System.Windows.Forms.ColumnHeader colName;
		private System.Windows.Forms.ColumnHeader colTransfer;
		private System.Windows.Forms.ColumnHeader colMessage;
		private System.Windows.Forms.ListBox lstOnline;
		private System.Windows.Forms.Button cmdClearLogg;
		private System.Windows.Forms.Label lblLog;
		private System.Windows.Forms.MenuItem mnuDelete;
		private System.Windows.Forms.Button cmdStop;
		private System.Windows.Forms.Label lblOnline;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		private UserList userList;
		private Socket connection;
		private bool running;	

		public Hub()
		{
			InitializeComponent();
			userList = new UserList();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Hub));
			this.cmdRun = new System.Windows.Forms.Button();
			this.lblIP = new System.Windows.Forms.Label();
			this.txtIP = new System.Windows.Forms.TextBox();
			this.mnuMenu = new System.Windows.Forms.MainMenu();
			this.mnuFile = new System.Windows.Forms.MenuItem();
			this.mnuAdd = new System.Windows.Forms.MenuItem();
			this.mnuDelete = new System.Windows.Forms.MenuItem();
			this.lvwLogg = new System.Windows.Forms.ListView();
			this.colName = new System.Windows.Forms.ColumnHeader();
			this.colTransfer = new System.Windows.Forms.ColumnHeader();
			this.colMessage = new System.Windows.Forms.ColumnHeader();
			this.lstOnline = new System.Windows.Forms.ListBox();
			this.cmdClearLogg = new System.Windows.Forms.Button();
			this.lblLog = new System.Windows.Forms.Label();
			this.lblOnline = new System.Windows.Forms.Label();
			this.cmdStop = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// cmdRun
			// 
			this.cmdRun.Location = new System.Drawing.Point(272, 16);
			this.cmdRun.Name = "cmdRun";
			this.cmdRun.TabIndex = 0;
			this.cmdRun.Text = "Run";
			this.cmdRun.Click += new System.EventHandler(this.cmdRun_Click);
			// 
			// lblIP
			// 
			this.lblIP.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblIP.Location = new System.Drawing.Point(16, 16);
			this.lblIP.Name = "lblIP";
			this.lblIP.Size = new System.Drawing.Size(32, 23);
			this.lblIP.TabIndex = 1;
			this.lblIP.Text = "IP: ";
			// 
			// txtIP
			// 
			this.txtIP.Location = new System.Drawing.Point(48, 16);
			this.txtIP.Name = "txtIP";
			this.txtIP.ReadOnly = true;
			this.txtIP.TabIndex = 2;
			this.txtIP.TabStop = false;
			this.txtIP.Text = "";
			// 
			// mnuMenu
			// 
			this.mnuMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					this.mnuFile});
			// 
			// mnuFile
			// 
			this.mnuFile.Index = 0;
			this.mnuFile.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					this.mnuAdd,
																					this.mnuDelete});
			this.mnuFile.Text = "&File";
			// 
			// mnuAdd
			// 
			this.mnuAdd.Index = 0;
			this.mnuAdd.Text = "&Add user";
			this.mnuAdd.Click += new System.EventHandler(this.ManageUsers);
			// 
			// mnuDelete
			// 
			this.mnuDelete.Index = 1;
			this.mnuDelete.Text = "&Delete user";
			this.mnuDelete.Click += new System.EventHandler(this.ManageUsers);
			// 
			// lvwLogg
			// 
			this.lvwLogg.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																					  this.colName,
																					  this.colTransfer,
																					  this.colMessage});
			this.lvwLogg.FullRowSelect = true;
			this.lvwLogg.Location = new System.Drawing.Point(16, 64);
			this.lvwLogg.Name = "lvwLogg";
			this.lvwLogg.Size = new System.Drawing.Size(564, 200);
			this.lvwLogg.TabIndex = 3;
			this.lvwLogg.TabStop = false;
			this.lvwLogg.View = System.Windows.Forms.View.Details;
			// 
			// colName
			// 
			this.colName.Text = "To/From";
			this.colName.Width = 100;
			// 
			// colTransfer
			// 
			this.colTransfer.Text = "Direction";
			// 
			// colMessage
			// 
			this.colMessage.Text = "Message";
			this.colMessage.Width = 400;
			// 
			// lstOnline
			// 
			this.lstOnline.Location = new System.Drawing.Point(592, 64);
			this.lstOnline.Name = "lstOnline";
			this.lstOnline.Size = new System.Drawing.Size(136, 199);
			this.lstOnline.TabIndex = 4;
			// 
			// cmdClearLogg
			// 
			this.cmdClearLogg.Location = new System.Drawing.Point(504, 16);
			this.cmdClearLogg.Name = "cmdClearLogg";
			this.cmdClearLogg.TabIndex = 5;
			this.cmdClearLogg.Text = "Clear Log";
			this.cmdClearLogg.Click += new System.EventHandler(this.cmdClearLogg_Click);
			// 
			// lblLog
			// 
			this.lblLog.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblLog.Location = new System.Drawing.Point(16, 48);
			this.lblLog.Name = "lblLog";
			this.lblLog.TabIndex = 6;
			this.lblLog.Text = "Log:";
			// 
			// lblOnline
			// 
			this.lblOnline.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblOnline.Location = new System.Drawing.Point(592, 48);
			this.lblOnline.Name = "lblOnline";
			this.lblOnline.TabIndex = 7;
			this.lblOnline.Text = "Users online:";
			// 
			// cmdStop
			// 
			this.cmdStop.Enabled = false;
			this.cmdStop.Location = new System.Drawing.Point(376, 16);
			this.cmdStop.Name = "cmdStop";
			this.cmdStop.TabIndex = 8;
			this.cmdStop.Text = "Stop";
			this.cmdStop.Click += new System.EventHandler(this.cmdStop_Click);
			// 
			// Hub
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(744, 289);
			this.Controls.Add(this.cmdStop);
			this.Controls.Add(this.cmdClearLogg);
			this.Controls.Add(this.lstOnline);
			this.Controls.Add(this.lvwLogg);
			this.Controls.Add(this.txtIP);
			this.Controls.Add(this.lblIP);
			this.Controls.Add(this.cmdRun);
			this.Controls.Add(this.lblLog);
			this.Controls.Add(this.lblOnline);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Menu = this.mnuMenu;
			this.Name = "Hub";
			this.Text = "P2PBackup";
			this.ResumeLayout(false);

		}
		#endregion

		[STAThread]
		static void Main() 
		{
			Application.Run(new Hub());
		}
		/// <summary>
		/// Accepts a connection from a client, creates a User with this connection
		/// Calls method to place the user in listening mode
		/// Adds the user to the UserList and Online Users's listbox after verification
		/// </summary>
		private void AcceptClient(IAsyncResult iar)
		{
			try
			{
				Socket hub = (Socket)iar.AsyncState;
				Socket client = hub.EndAccept(iar);
				User u = new User(client);
				u.LoggEvent += new P2PBackupHub.User.LoggHandler(Logg);

				// adds the user to the UserList after verification
				u.AddUserEvent += new P2PBackupHub.User.AddUserHandler(userList.AddUser);
				u.AddUserEvent += new P2PBackupHub.User.AddUserHandler(AddOnlineUser);
				// removes a user gone offline
				u.RemoveUserEvent += new P2PBackupHub.User.RemoveUserHandler(RemoveOfflineUser);
				
				u.StartListening();
				hub.BeginAccept(new AsyncCallback(AcceptClient), hub);
			}
			catch(ObjectDisposedException)
			{
				// socket closed when user logged out, do nothing
			}
			catch(Exception ex)
			{
				MessageBox.Show(ex.Message,"Hub.Hub.AcceptClient");
			}
		}

		/// <summary>
		/// Checks if the users are still online
		/// if not, removes it
		/// </summary>
		private void RemoveConnections()
		{
			try
			{
				while(this.running)
				{
					Thread.Sleep (1000);

					foreach(User u in userList)
					{		
						if (u.Connection.Poll (1000, SelectMode.SelectRead))
							if (u.Connection.Available == 0)
								u.Logout();								
					}
				}	
			}
			catch(Exception)
			{
				if(this.running)
					RemoveConnections();
			}
		}

		/// <summary>
		/// Creates a socket for incoming connections from clients
		/// Starts a thread that removes lost connections
		/// </summary>
		private void cmdRun_Click(object sender, System.EventArgs e)
		{
			try
			{
				if(!this.running)
				{
					this.running = true;
					Socket hub = new Socket(AddressFamily.InterNetwork,SocketType.Stream,ProtocolType.Tcp);
					connection = hub;
					IPEndPoint src = new IPEndPoint(IPAddress.Any, 52561);
					hub.Bind(src);
					hub.Listen(1000);
					hub.BeginAccept(new AsyncCallback(AcceptClient),hub);
					Thread t = new Thread(new ThreadStart(this.RemoveConnections));
					t.IsBackground = true;
					t.Start();
					txtIP.Text = ((IPHostEntry)Dns.GetHostByName("")).AddressList[0].ToString();
					cmdStop.Enabled = true;
					cmdRun.Enabled = false;
				}
			}
			catch(Exception ex)
			{
				MessageBox.Show(ex.Message,"Hub.Hub.cmdRun_Click");
			}
		}

		/// <summary>
		/// Event triggered by click on either Add or Delete user in the menu
		/// Opens a new form and allows addition/deletion of a user
		/// </summary>
		private void ManageUsers(object sender, System.EventArgs e)
		{
			UserForm uForm = new UserForm ();

			// if Delete is clicked
			if (sender == mnuDelete)
			{
				uForm.cmdAdd.Enabled = false;
				uForm.txtPassword.Enabled = false;
			}
			else
				uForm.cmdDelete.Enabled = false;

			DialogResult r = uForm.ShowDialog(); 
			
			// if Add User is clicked
			if(r == DialogResult.OK)
			{
				User u = new User(uForm.UserName, uForm.Password);
				u.AddNewUser();
			}
			// if Delete user is clicked
			else if (r == DialogResult.Yes)
			{
				User u = new User(uForm.UserName);
				u.DeleteUser(uForm.UserName);
			}
			else
				uForm.Close();
		}

		/// <summary>
		/// Logs all messages between user and hub
		/// </summary>
		/// <param name="name">sending/receiving user</param>
		/// <param name="received">direction of the transfer - received or sent</param>
		/// <param name="message">the message received or sent</param>
		private void Logg(string name, bool received, string message)
		{
			string transfer = "received";
			if(!received)
				transfer = "sent";
			string[] item = {name,transfer,message}; 
			lvwLogg.Items.Add(new ListViewItem(item));
			// scroll the logg
			lvwLogg.EnsureVisible(lvwLogg.Items.Count - 1);
		}

		/// <summary>
		/// Adds a verified user in the listbox
		/// </summary>
		/// <param name="user">the user to be added</param>
		private void AddOnlineUser(User user)
		{
			lstOnline.Items.Add(user.UserName);
		}

		/// <summary>
		/// Removes a user from the listbox, the user is no longer online
		/// </summary>
		/// <param name="user">the user to be removed</param>
		private void RemoveOfflineUser(User user)
		{
			lstOnline.Items.Remove(user.UserName);
		}

		/// <summary>
		/// Clears the log
		/// </summary>
		private void cmdClearLogg_Click(object sender, System.EventArgs e)
		{
			lvwLogg.Items.Clear();
		}

		/// <summary>
		/// Logs out all online users and stops the hub
		/// </summary>
		private void cmdStop_Click(object sender, System.EventArgs e)
		{
			User u;
			try
			{
				if(this.running)
				{
					this.running = false;
					Thread.Sleep(1000);

					for (int i = 0; i < userList.Count; i++)
					{
						u = (User)userList[i];
						u.Logout();
						i = i - 1;
					}

					if(connection != null)
					{
						connection.Close();
						txtIP.Text = "";
					}
				}

				cmdRun.Enabled = true;
				cmdStop.Enabled = false;
			}
			catch(Exception ex)
			{
				MessageBox.Show(ex.Message,"Hub.Hub.cmdStop_Click");
			}
		}
	}
}
